//
//buffer.c
//
//Functions for manipulating buffers.
//
//
//-UserX 2001/12/10

#include "compat.h"
#include <string.h>
#include "buffer.h"

//xor buffers
void bufferXor(uint8 *dstbuffer, uint8 *srcbuffer, int length) {
	int i;
	for(i = 0; i < length; i++) {
		dstbuffer[i] ^= srcbuffer[i];
	}
}

//swap buffers
void bufferSwap(uint8 *dstbuffer, uint8 *srcbuffer, int length) {
	bufferXor(dstbuffer, srcbuffer, length);
	bufferXor(srcbuffer, dstbuffer, length);
	bufferXor(dstbuffer, srcbuffer, length);
}

//swap buffers with a temporary space
void bufferSwap3(uint8 *dstbuffer, uint8 *srcbuffer, uint8 *tmpbuffer, int length) {
	memcpy(tmpbuffer, srcbuffer, length);
	memcpy(srcbuffer, dstbuffer, length);
	memcpy(dstbuffer, tmpbuffer, length);
}

//inc buffer (big endian)
void bufferInc(uint8 *dstbuffer, int length) {
	int i;
	for(i = length - 1; i >= 0; i++) {
		if(++dstbuffer[i] != 0) {
			break;
		}
	}
}
//dec buffer (big endian)
void bufferDec(uint8 *dstbuffer, int length) {
	int i;
	for(i = length - 1; i >= 0; i++) {
		if(dstbuffer[i]-- != 0) {
			break;
		}
	}
}

