//
//core.c
//
//
//
//
//-UserX 2001/11/09

//#include <stdio.h>

#include "core.h"
#include "sock.h"
#include "sockserv.h"
#include "wingui.h"
#include "messageq.h"
#include "pf-msg.h"
#include "global.h"
#include "protocol.h"
#include "isproxy.h"

PipeFaceArray *PFA = NULL;
MessageQueue *MQ = NULL;

void coreInit(void) {
	if(PFA == NULL) {
		PFA = pfaMake();
	}
	if(MQ == NULL) {
		MQ = msgqMake();
	}
}

//start connection of an inbound socket to the core
void coreAddInSock(SockHandle *sh, int *result) {
	SockHandle *nsh;
	PipeFace *pf;
	PipeFace *opf;
	if(sh == NULL) {
		*result = 1;
		return;
	}
	nsh = sockservConnect();
	if(nsh == NULL) {
		sockClose(sh);
		sockFree(sh);
		*result = 1;
		return;
	}

	//pf = pipefaceMake();
	//opf = pipefaceMake();
	//todo: check sh for what protocol this new connection is for.
	//pipefaceInit(pf, &sh->IOPipe);
	//pipefaceInitFuncs(pf, pfGetMsg, pfPutMsg, NULL);
	//pf->PipeFaceType = PFT_RAW;
	//pfaAdd(PFA, pf);

	//pipefaceInit(opf, &nsh->IOPipe);
	///pipefaceInitFuncs(opf, pfGetMsg, pfPutMsg, NULL);
	//opf->PipeFaceType = PFT_RAW;
	//pfaAdd(PFA, opf);

	//todo: handle the case where no pipeface is returned.
	pf = protocolBuildPipe(sh, sh->localnoderef->Protocol);
	if(pf == NULL) {
		sockClose(sh);
		sockFree(sh);
		*result = 1;
		return;
	}
	opf = protocolBuildPipe(nsh, nsh->noderef->Protocol);
	if(opf == NULL) {
		sockClose(sh);
		sockFree(sh);
		pipefaceClose(pf);
		*result = 1;
		return;
	}

	pfaAdd(PFA, pf);
	pfaAdd(PFA, opf);

	pf->opposite = opf;
	opf->opposite = pf;

	*result = 0;
	return;
}






void coreSwapPipeFace(PipeFace *oldpf, PipeFace *newpf) {
	pfaSwap(PFA, oldpf, newpf);
}



void coreProcessPipeFace(void) {
	int i;
	Message *msg;
	msgqCompact(MQ);
	for(i = 0; i < PFA->size; i++) {
		if(PFA->data[i] != NULL) {
			pipeGenericRead(PFA->data[i]->IOPipe.backPipe);
			pipeGenericWrite(PFA->data[i]->IOPipe.backPipe);
			while((msg = pipefaceGetMessage(PFA->data[i])) != NULL) {
				msgqAdd(MQ, msg);
			}
			if(pipeStatus(PFA->data[i]->IOPipe.backPipe) & PSTATUS_CLOSED) {
				if(PFA->data[i]->opposite != NULL) {
					pfaDelete(PFA, PFA->data[i]->opposite); 
					pipefaceClose(PFA->data[i]->opposite);
				}
				pipefaceClose(PFA->data[i]);
				PFA->data[i] = NULL;
				
			}
		}
	}
}

void coreProcessMessageQueue(void) {
	int i;
	int j;
	for(i = 0; i < MQ->size; i++) {
		//todo: better delegation when real messages get added.
		if(MQ->data[i] != NULL) {
			j = pfaFindByITag(PFA, MQ->data[i]->fromitag);
			if(j == -1) {
				messageFree(MQ->data[i]);
			} else {
				pipefacePutMessage(PFA->data[j]->opposite, MQ->data[i]);
			}
			MQ->data[i] = NULL;
		}
	}
}

void coreStart(void) {
//	NodeRef *nr = noderefMake();

	sockservInit(coreAddInSock);
	coreInit();

	sockservStartListen();

//	noderefInit(nr, "0.0.0.0", "plain", localPort);
//	sockservListen(nr);
//	noderefFree(nr);

}

void coreMainLoop(void) {
	//int i = 0;
	coreStart();
	while(1) {
#ifdef _WINDOZE_
		if(dowindows()) {
			break;
		}
#endif
		if(reloadsettings != 0) {
			iipReload();
		}
		sockservProcess();
		coreProcessPipeFace();
		coreProcessMessageQueue();
		//i = (i++) % 8;
		//printf("%c", "-<{(|)}>"[i]);
		//printf("\b");
	}
}
