/*
 *
 * Compile with:
 *     cc -O -o isproxy isproxy.c
 * On Solaris/SunOS, compile with:
 *     gcc -Wall isproxy.c -lsocket -lnsl -o isproxy
 * On Windows compile with:
 *     bcc32 /w isproxy.c                (Borland C++)
 *     cl /W3 isproxy.c wsock32.lib      (Microsoft Visual C++)
 *   Unix and Win32 Compatible
 *
 * written by the Invisible Irc Dev Duo 0x90 and fish (phish)
 *<0x90@hushmail.com> & fish: <fish@artificial-stupidity.net> 
 */



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <signal.h>

#include "compat.h"
#ifdef _WINDOZE_
	#include "wingui.h"
#else
//	#include <sys/time.h>
//	#include <sys/types.h>
//	#include <sys/wait.h>
//	#include <netinet/in.h>
//	#include <arpa/inet.h>
//	#include <unistd.h>
//	#include <netdb.h>
//	#include <strings.h>
//	#define recv(x,y,z,a) read(x,y,z)
//	#define send(x,y,z,a) write(x,y,z)
//	#define closesocket(s) close(s)
#endif
#include "isproxy.h"
#include "memiip.h"

#include "random.h"
#include "salt.h"
#include "nodeserv.h"
#include "core.h"
#include "debug.h"
#include "bignum.h"
#include "crypt-dh.h"
#include "global.h"

#include "logger.h"

#include "noderef.h"
#include "nodeserv.h"
#include "protocol.h"
#include "protocfg.h"
#include "pipe.h"
#include "pipeface.h"
#include "pf-msg.h"
#include "pf-virc.h"
#include "p-crypt.h"
#include "p-steady.h"
#include "p-spurt.h"
#include "p-back.h"
#include "p-masq.h"
#include "p-dummy.h"
#include "p-nodet.h"
#include "config.h"
#include "cui.h"

#include "ui-dumb.h"
#include "iip-ui.h"

#include "sockserv.h"

#ifdef _UNIX_
#include "unix.h"
#endif

const char ident[] = "$Id: isproxy.c,v 1.26 2002/04/11 05:43:51 userxiip Exp $";



//todo: put this somewhere else
int doFork=TRUE;


PipeProtocolEntry ppelist[] = {
	{"backward", pipebackwardMake},
	{"crypt", pipecryptMake},
	{"steady", pipesteadyMake},
	{"spurt", pipespurtMake},
	{"nodeget", pipenodetransMake},
	{"nodesend", pipenodetransMake},
	BLANKPIPEPROTOCOLENTRY
};

PipeFaceProtocolEntry pfpelist[] = {
	{"core", pfcoreMake},
	{"raw", pfcoreMake},
	{"virc", pfvircMake},
	BLANKPIPEFACEPROTOCOLENTRY
};

//todo: validate functions
ConfigEntry ceinit[] = {
	{CETYPE_STRING, {"configfile", "c"}, CEIB, {&configfilename, DEFAULT_CONFIGNAME}, CEFB, NULL, NULL},
	{CETYPE_INT, {"port", "p"}, {&localPort, -1}, CESB, CEFB, NULL, NULL},
	{CETYPE_STRING, {"host", NULL}, CEIB, {&hostname, NULL}, CEFB, NULL, NULL},
	{CETYPE_STRING, {"logfile", "l"}, CEIB, {&logfilename, DEFAULT_LOGFILE}, CEFB, NULL, NULL},
	{CETYPE_INT, {"loglevel", "v"}, {&verbosity, 2}, CESB, CEFB, NULL, NULL},
	{CETYPE_STRING, {"nodefile", NULL}, CEIB, {&nodereffilename, DEFAULT_NODEREFFILENAME}, CEFB, NULL, NULL},
	{CETYPE_STRING, {"listenfile", NULL}, CEIB, {&listenreffilename, DEFAULT_LISTENFILENAME}, CEFB, NULL, NULL},
	{CETYPE_BOOL, {"publicrelay", NULL}, {&publicrelaynode, 0}, CESB, CEFB, NULL, NULL},
	{CETYPE_BOOL, {"autogetnoderefs", NULL}, {&autogetnoderefs, 0}, CESB, CEFB, NULL, NULL},
	{CETYPE_INT, {"steadymin", NULL}, {&pipesteadyminimum, 10}, CESB, CEFB, NULL, NULL},
	{CETYPE_INT, {"steadymax", NULL}, {&pipesteadymaximum, 20}, CESB, CEFB, NULL, NULL},
	{CETYPE_FUNC, {"protocolgood", NULL}, CEIB, CESB, {protocolAddGood, protocolGetGood, protocolClearGood}, NULL, NULL},
	{CETYPE_FUNC, {"protocolbad", NULL}, CEIB, CESB, {protocolAddBad, protocolGetBad, protocolClearBad}, NULL, NULL},
	{CETYPE_STRING, {"informhost", NULL}, CEIB, {&informhost, DEFAULT_INFORMHOST}, CEFB, NULL, NULL},
	{CETYPE_INT, {"informport", NULL}, {&informport, DEFAULT_INFORMPORT}, CESB, CEFB, NULL, NULL},
	{CETYPE_STRING, {"informpage", NULL}, CEIB, {&informpage, DEFAULT_INFORMPAGE}, CEFB, NULL, NULL},
	{CETYPE_STRING, {"refgethost", NULL}, CEIB, {&refgethost, DEFAULT_REFGETHOST}, CEFB, NULL, NULL},
	{CETYPE_INT, {"refgetport", NULL}, {&refgetport, DEFAULT_REFGETPORT}, CESB, CEFB, NULL, NULL},
	{CETYPE_STRING, {"refgetpage", NULL}, CEIB, {&refgetpage, DEFAULT_REFGETPAGE}, CEFB, NULL, NULL},

	{CETYPE_BOOL, {"nodetransget", NULL}, {&nodetransget, 1}, CESB, CEFB, NULL, NULL},
	{CETYPE_BOOL, {"nodetranssend", NULL}, {&nodetranssend, 0}, CESB, CEFB, NULL, NULL},
	{CETYPE_STRING, {"nodetransfile", NULL}, CEIB, {&nodetransfile , ""}, CEFB, NULL, NULL},

	{CETYPE_STRING, {"winhelpfile", NULL}, CEIB, {&winhelpfile , "iip.chm"}, CEFB, NULL, NULL},

	BLANKCONFIGENTRY
};


int initfirst(void) {
	memInit();

	protocolInit();
	protocolAddPipeList(ppelist);
	protocolAddPipeFaceList(pfpelist);

	configInit();
	configAddList(ceinit);

	saltInit();
	randomInit();

	return 0;
}


int init() {
	BigNum *privkey;
	BigNum *pubkey;
#ifndef _WINDOZE_
	int i;
#endif

	//randomInit() is called twice but done just in case another random seed is found/pointed to
	randomInit();

	doTests();

	if(makeKeys != 0) {
		privkey = dhGeneratePrivKey();
		pubkey = dhGeneratePubKey(privkey);
		
		LOGNONE(stringJoin("Private key:", bignumToHex(privkey)));
		LOGNONE(stringJoin("Public  key:", bignumToHex(pubkey)));
		exit(0);
	}
	SocketAtStart();

	//todo: display something for windows
	if(autogetnoderefs != 0) {
		LOGNORMAL("Retrieving node.ref");
		if(nodeservGetNodeRefs(refgetpage, refgethost, refgetport) != 0) {
			LOGERROR("Error when automaticly retrieving node.ref");
		}
	}

	nodeservClearNodeRefs();
	nodeservReadNodeRefFile();
	nodeservClearListenRefs();
	nodeservReadListenRefFile();

	if(doconfig != 0) {
		iipcsScreen();
		//todo: unix: send SIGHUP to all running copies and exit. (don't exit if no other copies are running)
#ifdef _UNIX_
		if(unixSighupKin("/var/tmp/", "isproxy.lock.") != 0) {
			return 0;
		}
#endif
	}

	logstring(LOG_NORMAL, stringAppend2(
			"Accepting IRC connections on port:", intToString(localPort)
		));
	logstring(LOG_NORMAL,stringAppend3(
			"Type /server localhost:", 
			intToString(localPort),
			" to connect, and then /join #anonymous"
		));

	/* fork off into the background. */
#ifdef _UNIX_
	if(doFork)
	{
		if ((i = fork()) == -1) {
			perror("fork");
			return 20;
		}
		if (i > 0) {
			return 0;
		}
		setsid();
	}
	unixAddLockFile("/var/tmp/", "isproxy.lock.");
#endif

	// enter the main loop
	coreMainLoop();

	return 0;

}


int main(int argc, char **argv)
{ 
	int i;

	initfirst();

	uiSetFuncs(uidumbMake, uidDialog);

	configReset();
	configSetCL(argc, argv);
	configReadCL();
	//readCL(argc, argv);
	//readConfigFile();
	configRead();
	configReadCL();

	if(makeKeys == 0) {
		if(localPort == -1) {
			//localPort = getLocalPort();
			nodeservClearListenRefs();
			nodeservReadListenRefFile();
			iipcsScreen();
			doconfig = 0;
		}
		if(localPort == -1) {
			return 10;//todo: choose a better exit code
		}
	}
#ifdef _UNIX_
	signal(SIGHUP, unixSignalHUP);
#endif
	i = init();  
	return i;

}

void iipReload(void) {
	LOGNORMAL("iipReload: Reloading settings.");
	configReset();
	configReadCL();
	configRead();
	configReadCL();
	nodeservClearNodeRefs();
	nodeservReadNodeRefFile();
	nodeservClearListenRefs();
	nodeservReadListenRefFile();
	reloadsettings = 0;
	sockservStartListen();
}

