/*
 * Invisible IRC server v0.2
 *
 * (c) 2001, 0x90 (0x90@hushmail.com) and fish (fish@artificial-stupidity.net)
 *
 * WWW - http://invisibleirc.invisblestudios.net
 * freenet 0.3 - freenet:MSK@SSK@gCEgB3bQMhkK39jPN-fRFOtuUaYQAgE/techgrounds//
 * freenet 0.4 - freenet:SSK@kj9mFvMP4IROkObPHFPlapSnjj0PAgM/techgrounds//
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
  #define WIN32_LEAN_AND_MEAN
  #include <winsock.h>
  #define bzero(p, l) memset(p, 0, l)
  #define bcopy(s, t, l) memmove(t, s, l)
#else
  #include <sys/time.h>
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <sys/wait.h>
  #include <netinet/in.h>
  #include <arpa/inet.h>
  #include <unistd.h>
  #include <netdb.h>
  #include <strings.h>
  #define recv(x,y,z,a) read(x,y,z)
  #define send(x,y,z,a) write(x,y,z)
  #define closesocket(s) close(s)
  typedef int SOCKET;
#endif
#include "isproxy.h"
  
#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#define  INADDR_ANY ((in_addr_t) 0x00000000)
#endif

struct channel_t
{
	char name[CHANNELLEN];
	char nickList[1024][CHANNELLEN];
	int listeners[MAXNODES];
	int numListeners;
	int local;
	int origin;
	int numNicks;
};
		
struct request_t
{
	int type;
	int probes;
	int origin;
	char cookie[COOKIELEN];
};

struct client_t
{
  int inuse;
  SOCKET csock, osock;
  time_t activity;
  char *buffer;
  int bufferLevel;
  int bufferSize;

  
// this stuff probably should be somewhere else, but I'm putting it here 
  // for now
  // it's the irc stuff.
  char nick[NICKLEN];
  char realName[NAMELEN];
  char ident[IDENTLEN];
  int seenMotd;

  // this stuff is tied up with peer-peer node communication.  it also should
  // be elsewhere, or at least a union with the IRC stuff, since it's always 
  // one or the other....
  int version;
  int peerok;
  node remote;

  // This stuff is for crypto, of course ;).
  char pubKey[KEYLEN+1];
};


#define IDLETIMEOUT 300
FILE *fp;

const char ident[] = "$Id: isproxy2.c,v 1.1.1.1 2001/11/08 21:25:23 heretic108 Exp $";
// remote address - this needs to be changed to be non-global, but it needs
// some of the structure changes that will be required by the peer-peer stuff
// first - so don't take advantage of this being here, because it needs to
// go away!
struct sockaddr_in oaddr;
struct client_t clients[MAXNODES];
struct channel_t channels[MAXNODES];
struct request_t requestQueue[RQUEUESIZE];
int numChannels;
char localh[15];
int localPort= -1;
node remoteHost;
int verbosity=1;
int doFork=TRUE;
time_t now;
char allowable[]="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

char myPubKey[KEYLEN+1];

int maxConnections=1;
int connectedNodes;
int lastRequest;

// prototypes
int createListener(int port, struct sockaddr_in *laddr);
void handleLocal(SOCKET lsock, fd_set *fsdr);
void handleTextData(SOCKET lsock, int clientNum);
void handleLocalData(SOCKET lsock, fd_set *fdsr);
void handleLocalConnection(SOCKET lsock, fd_set *fdsr);
void processIrcLine(int len, int i);
void processPeerInput(int len, int i);
void checkNodeNumbers();
void initiateNodeConnection(node remoteHost);
struct sockaddr_in getLocalAddr(int port);
struct sockaddr_in createRemoteAddr(char *remote, int port);
void processPeerOutput(int len, int i);
void createChannel(char *channelName, int local);
int addChannelListener(char *channelName, int i);
int findChannelByName(char *channelName);
void sendIrcChannelMessage(char *nick, char *ident, char *target, char *message, int exclude, char *cookie);
int addNickToChannel(char *channel, char *nick);
void addLocalListener(int which, int i);
void requestRemoteListener(char *channel, int i);
void generateCookie(char *where);
int createRequest(int type, int origin, char *cookie);
int sendToAllNodes(char *command, int exclude, int r);
void processPeerCommon(char *myBuf, int i);
void sendNoRoute(char *cookie);
int getQueueNum(char *cookie);
void createRemoteChannelHere(char *channel, char *cookie, int i);
void sendIrcNamesList(int i, char *channel, char *list);
void createNickList(char *list, char *channel);
void sendChannelJoin(char *channel, char *nick, char *ident, int exclude, char *cookie);
void mainLoop();

int main(int argc, char **argv)
{ 
  int i;
  int p;
  srandom(time(NULL));


  // Parse the options
  for(p=1;p<argc;p++)
  {
	  // a valid parameter
	  if(argv[p][0]='-')
	  {
		  // here for more advanced procesisng later...
		  switch(argv[p][1])
		  {
			  case 'h':
			  case 'H':
				  showHelp();
				  exit(0);
			  case 'v':
				  if(argv[p][2]==0)
					  verbosity=2;
				  else
				  	verbosity=atoi(&argv[p][2]); 
				  break;
			  case 'd':
				  doFork=FALSE;
				  break;
			  case 'p':
				  localPort=atoi(&argv[p][2]);
				  break;
				  
			  default:
				  printf("Invalid Parameter - type -h to see what is valid\n"
						  "Sorry it didn't work out!\n");
				  exit(1);
				  break;
		  }
	  }
	  // a number on it's own is a host to seed from (or |file) - this
	  // won't work, of course, until there is seeding code written later
	  else
	  {
		  printf("I'm sorry, the code for seeding hasn't been written yet\n"
				  "Sorry it didn't work out!\n");
		  exit(1);
	  }
  }

  // clear the request structure
  lastRequest=0;
  for(p=0;p<RQUEUESIZE;p++)
	requestQueue[p].cookie[0]=0;

  // generate a public key....
  for(p=0;p<KEYLEN;p++)
  {
	  myPubKey[p]=allowable[random()%strlen(allowable)];
  }
  myPubKey[KEYLEN]=0;
  printf("Public Key: %s\n", myPubKey);
  
  // read node.ref to start up....
  mergeNodeRef("node.ref.2");
  connectedNodes=0;
  numChannels=0;
  
#if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
  /* Winsock needs additional startup activities */
  WSADATA wsadata;
  WSAStartup(MAKEWORD(1,1), &wsadata);
#endif

	if(localPort== -1)
		localPort=getLocalPort();
  
	if(verbosity>0)
	{
		printf("Accepting IRC connections on port: %d\n", localPort);
		printf("Type /server localhost:%d to connect, and then\n"
			"/join #anonymous\n", localPort);
	}

	/* reset all of the client structures */
	for (i = 0; i < MAXNODES; i++)
	{
		clients[i].inuse = 0;
		clients[i].buffer=NULL;
		clients[i].bufferSize=0;
		clients[i].bufferLevel=0;
	}

#if 0  

  /* fork off into the background. */
#if !defined(__WIN32__) && !defined(WIN32) && !defined(_WIN32)
  if(doFork)
  {
	  if ((i = fork()) == -1) {
	    perror("fork");
	    return 20;
	  }
	  if (i > 0)
	    return 0;
	  setsid();
  }
#endif

#endif

	// and start the main loop
	mainLoop();
  
}


void mainLoop()
{
 	struct sockaddr_in laddr;
	SOCKET lsock;
	fd_set fdsr;
	int i;
	int lastNodeCheck=0;
	int nodeCheckInterval=10;

	// create listener
	lsock=createListener(localPort, &laddr);

	// wait for a connection....
	while(1)
	{
		struct timeval tv = {1,0};
		int maxsock;
    		now = time(NULL);
		
		// keep up the node count....
		//if((now-lastNodeCheck)>nodeCheckInterval)
		{
			if(verbosity>2)
				printf("node count check...\n");
			checkNodeNumbers();
			lastNodeCheck=now;
		}
		
    		// build the list of sockets to check.
		FD_ZERO(&fdsr);
		FD_SET(lsock, &fdsr);
		maxsock = (int) lsock;
    
		for (i = 0; i < MAXNODES; i++)
			if (clients[i].inuse) 
			{
				// set the input socket for checking...
				FD_SET(clients[i].csock, &fdsr);
				if ((int) clients[i].csock > maxsock)
					maxsock = (int) clients[i].csock;
			}

		// do the select
		if (select(maxsock + 1, &fdsr, NULL, NULL, &tv) < 0) {
			perror("select");
			exit(30);
		}
		handleLocalConnection(lsock, &fdsr);
		handleLocalData(lsock, &fdsr);		
	}
}

int createRequest(int type, int origin, char *cookie)
{
	requestQueue[lastRequest].type=type;	
	requestQueue[lastRequest].origin=origin;	
	requestQueue[lastRequest].probes=0;
	strcpy(requestQueue[lastRequest].cookie, cookie);
	lastRequest++;
	return lastRequest-1;
}

void checkNodeNumbers()
{
	if(connectedNodes<maxConnections)
	{
		// Pick a random node to connect to for now....
		remoteHost=pickRandomNode();
		if(remoteHost.port>0)
			initiateNodeConnection(remoteHost);
	}
}

void initiateNodeConnection(node remoteHost)
{
	char buf[4000];
	int i;
	SOCKET s;
	printf("Connecting to node: %s:%d\n", remoteHost.host, remoteHost.port);
	s=makeExternalConnection(remoteHost);
	if(s == -1) 
	{
		removeNode(remoteHost);
		return;
	}
	sprintf(buf, "iamnode\n");
	send(s, buf, strlen(buf), 0);
	sprintf(buf, "version%d\n", myVersion);
	send(s, buf, strlen(buf), 0);
	// FIXME: send a hostname if the user has specified on in the config.
	// this, of course, requires a config file....
	sprintf(buf, "port%d\n", localPort);
	send(s, buf, strlen(buf), 0);

	// public key needs ot be the very last thing we send - the encrypted 
	// connection starts once both ends have the other's public key
	sprintf(buf, "publickey%s\n", myPubKey);
	send(s, buf, strlen(buf), 0);

	for (i = 0; i < MAXNODES; i++)
		if (!clients[i].inuse) break;
          	
	// place data in to the slot - current socket
	clients[i].csock = s;
	clients[i].activity = now;
	clients[i].inuse = NODE_TYPE_PEER_OUT;
	clients[i].peerok = 0;
	clients[i].remote=remoteHost;
	connectedNodes++;
}

struct sockaddr_in createRemoteAddr(char *remote, int port)
{
	struct sockaddr_in oaddr;
	/* determine the outgoing address and port */
	bzero(&oaddr, sizeof(struct sockaddr_in));
	oaddr.sin_family = AF_INET;
	oaddr.sin_port = htons((unsigned short)port);
	if (!oaddr.sin_port) 
	{
		fprintf(stderr, "invalid target port\n");
		exit(25);
	}
	
	oaddr.sin_addr.s_addr = inet_addr(remote);
	if (oaddr.sin_addr.s_addr == INADDR_NONE) 
	{
		struct hostent *n;
		if ((n = gethostbyname(remote)) == NULL) 
		{
			perror("gethostbyname");
			return oaddr;
		}
		bcopy(n->h_addr, (char *) &oaddr.sin_addr, n->h_length);
	}    
	return oaddr;
}


SOCKET makeExternalConnection(node remoteHost)
{
	// connect a socket to the outgoing host/port
	SOCKET osock;
	struct sockaddr_in oaddr=createRemoteAddr(remoteHost.host, remoteHost.port);
	struct sockaddr_in laddr=getLocalAddr(0);

	if ((osock = socket(PF_INET, SOCK_STREAM, 0)) == -1) 
	{
		perror("socket");
		closesocket(osock);
		osock= -1;
	}
	else if (bind(osock, (struct sockaddr *)&laddr, sizeof(laddr))) 
	{
		perror("bind");
		closesocket(osock);
		osock= -1;
        }
	else if (connect(osock, (struct sockaddr *)&oaddr, sizeof(oaddr))) 
	{
		perror("connect");
		if(verbosity>0)
			fprintf(stderr, "Couldn't connect to remote node\n");
		closesocket(osock);
		osock= -1;
        }
		
	return osock;
}
	

void handleLocalData(SOCKET lsock, fd_set *fdsr)
{
	int i;
	for (i = 0; i < MAXNODES; i++)
	{
		if(clients[i].inuse)
      			if (FD_ISSET(clients[i].csock, fdsr))
			{
				// We need to service this socket - pass it off
				// to the correct socket handler
				switch(clients[i].inuse)
				{
					case NODE_TYPE_IRC:
					case NODE_TYPE_PEER_IN:
					case NODE_TYPE_PEER_OUT:
						handleTextData(lsock, i);
						break;
					default:
						printf("Bad things happened...\n");
						abort();
						break;
				}
			}
	}
}

void handleTextData(SOCKET lsock, int i) 
{
	char buf[1024];
	int numBytes;
	int nl;
	if (!(numBytes = recv(clients[i].csock, buf, sizeof(buf), 0)))
	{
		// we need to close this socked.....
        	closesocket(clients[i].csock);
        	clients[i].inuse = 0;
	}
        else 
	{
		int newLevel;
		
		/*
		printf("buffer: ");		
		fwrite(buf, 1, numBytes, stdout);
		printf("\n");
		*/

		// update the activity meter
		clients[i].activity = now;

		// Update the buffer
		newLevel=clients[i].bufferLevel+numBytes;
		if(clients[i].bufferSize<newLevel)
			clients[i].buffer=realloc(clients[i].buffer, newLevel);

		// copy the data
		memcpy(clients[i].buffer+clients[i].bufferLevel, buf, numBytes);
		clients[i].bufferLevel=newLevel;

		// see if we have a newline			
		for(nl=0;nl<clients[i].bufferLevel;nl++)
			if(clients[i].buffer[nl]=='\n' || clients[i].buffer[nl]=='\r')
			{
				if(nl>0)
				{
					switch(clients[i].inuse)
					{
						case NODE_TYPE_IRC:
							processIrcLine(nl, i);
							break;
						case NODE_TYPE_PEER_IN:
							processPeerInput(nl, i);
							break;
						case NODE_TYPE_PEER_OUT:
							processPeerOutput(nl, i);
							break;
						default:
							printf("bad things at %d\n", __LINE__);
							break;
					}
				}
				else
				{
					clients[i].bufferLevel--;
					memmove(clients[i].buffer, clients[i].buffer+1, clients[i].bufferLevel);
				}
				nl= -1;
			}
	}
}

void processPeerOutput(int len, int i)
{
	char *myBuf;
	char cmd[1000];
	char buf[5000];
	
	// copy to my buffer
	myBuf=(char *)malloc(len+10);
	memcpy(myBuf, clients[i].buffer, len);
	myBuf[len]=0;
	
	// clear from original buffer
	clients[i].bufferLevel-=len;
	memmove(clients[i].buffer, clients[i].buffer+len, clients[i].bufferLevel);

	if(strncasecmp(myBuf, "ok", 2)==0)
	{
		// connection accepted.  joy!
		printf("remote peer accepts me and loves me!\n");
		clients[i].peerok=1;
	}
	else if(strncasecmp(myBuf, "rejected", 8)==0)
	{
		// rejected - d'oh!
		printf("remote peer rejected my sorry ass!\n");
		closesocket(clients[i].csock);
		clients[i].inuse=0;
		removeNode(clients[i].remote);
		connectedNodes--;
	}
	else if(strncasecmp(myBuf, "publickey", 9)==0)
	{
		strncpy(clients[i].pubKey, myBuf+9, KEYLEN);
		clients[i].pubKey[KEYLEN]=0;
		//printf("Remote peer public key: %s\n", clients[i].pubKey);
	}
	else if(strncasecmp(myBuf, "port", 4)==0)
	{
		clients[i].remote.port=atoi(myBuf+4);
		printf("Remote peer port: %d\n", clients[i].remote.port);
	}
	else
	{
		// common commands go below here
		processPeerCommon(myBuf, i);
	}
}

void processPeerInput(int len, int i)
{
	char *myBuf;
	char cmd[1000];
	char buf[5000];
	
	// copy to my buffer
	myBuf=(char *)malloc(len+10);
	memcpy(myBuf, clients[i].buffer, len);
	myBuf[len]=0;
	
	// clear from original buffer
	clients[i].bufferLevel-=len;
	memmove(clients[i].buffer, clients[i].buffer+len, clients[i].bufferLevel);

	if(strncasecmp(myBuf, "version", 7)==0)
	{
		clients[i].version=atoi(myBuf+7);
		printf("Connected peer is version %d\n", clients[i].version);	
	}
	else if(strncasecmp(myBuf, "publickey", 9)==0)
	{
		strncpy(clients[i].pubKey, myBuf+9, KEYLEN);
		clients[i].pubKey[KEYLEN]=0;

		// check that we're not connecting to ourself...
		if(strcmp(clients[i].pubKey, myPubKey)==0)
		{
			sprintf(buf, "rejected\n");
			printf("Peer is myself - closing off...\n");
          		send(clients[i].csock, buf, strlen(buf), 0);
			closesocket(clients[i].csock);
			clients[i].inuse=0;
		}
		else
		{
			// FIXME: check that the peer isn't already connect
			// to us - that shouldn't happen, but you know ;)
			sprintf(buf, "ok\n");
          		send(clients[i].csock, buf, strlen(buf), 0);
			//printf("Connected peer has a public key of %s\n", clients[i].pubKey);
			
			// send the remote peer our pubkey
			sprintf(buf, "publickey%s\n", myPubKey);
			send(clients[i].csock, buf, strlen(buf), 0);
		}
	}
	else
	{
		// common commands go below here
		processPeerCommon(myBuf, i);
	}
}
				
void sendChannelJoin(char *channel, char *nick, char *ident, int exclude, char *cookie)
{
	int which;
	int i;
	int x;
	int y;
	int num=0;
	char buf[4096];
	char mc[4096];

	if(cookie==NULL)
	{
		generateCookie(mc);
		createRequest(REQUEST_CHANNEL_JOIN, exclude, mc);
	}
	else
		strcpy(mc, cookie);

	printf("Sending join for %s to channel %s\n", nick, channel);
	which=findChannelByName(channel);
	
	for(x=0;x<channels[which].numListeners;x++)
	{
		i=channels[which].listeners[x];
		if(i!=exclude)
		{
			num++;
			switch(clients[i].inuse)
			{
				case 0: 
					break;
				case NODE_TYPE_IRC:
					sprintf(buf, ":%s!%s@%s JOIN :%s\n", nick, ident, servername, channel);
			          	send(clients[i].csock, buf, strlen(buf), 0);
					break;				
				default:
					sprintf(buf, "Join%s %s %s %s\n", channel, nick, ident, mc);
			          	send(clients[i].csock, buf, strlen(buf), 0);
					break;
			}
		}
	}
	// send on up to the next node
	if(!channels[which].local)
	{
		int w=channels[which].origin;
		if(w!=exclude)
		{
			sprintf(buf, "Join%s %s %s %s\n", channel, nick, ident, mc);
	          	send(clients[w].csock, buf, strlen(buf), 0);
			num++;
		}
	}
	printf("Send %s : %s to %d clients\n", channel, nick, num);
}

void processPeerCommon(char *myBuf, int i)
{
	if(strncasecmp(myBuf, "channel#", 8)==0)
	{
		char *d;
		char channel[1000];
		char cookie[1000];
		d=myBuf+7;
		sscanf(d, "%s %s", channel, cookie);
		printf("Requested listener: %s, cookie %s\n", channel, cookie);
		if(checkCookie(cookie, i))
		{
			int which;
			printf("Search for channel %s\n", channel);
			which=findChannelByName(channel);
			if(which>=0)
			{
				char message[1000];
				printf("Found channel %d\n", which);
				addLocalListener(which, i);
				// send to the remote end
				sprintf(message, "ChannelFound%s %s\n", channel, cookie);
				send(clients[i].csock, message, strlen(message), 0);
			}
			else
			{
				int r;
				int num;
				printf("%s not here - pass on to next node\n", channel);
				printf("Node: %d\n", i);
				// forward to next node
				r=createRequest(REQUEST_CHANNEL_LISTEN, i, cookie);

				// FIXME: deal with there being no more nodes...
				num=sendToAllNodes(myBuf, i, r);
				if(num==0)
				{
					int dice;
					// there is no channel here - decide wether to create it....
					dice=random()%2;
					//if(dice)
					{
						printf("No more nodes to route to - create channel here!\n");
						createRemoteChannelHere(channel, cookie, i);
					}
					//else
					//{
					//	printf("No more nodes to route to - send noroute\n");
					//	sendNoRoute(cookie);
					//}
				}
			}
		}
	}
	else if(strncasecmp(myBuf, "ChannelFound#", 13)==0)
	{
		char *d;
		char channel[1000];
		char cookie[1000];
		int c;
		int n;
		
		d=myBuf+12;
		sscanf(d, "%s %s", channel, cookie);
		printf("Channel Found: %s (cookie %s)\n", channel, cookie);

		// check that we don't already have a listener to this channel
		n=findChannelByName(channel);
		if(n<0)
		{
			int c;
			int p;
			int d;
			// we don't have the channel, indeed.  joy!
			// add it to our own lists
			createChannel(channel, FALSE);
			c=findChannelByName(channel);
			channels[c].origin=i;

			// add the requestor as a listener
			p=getQueueNum(cookie);
			addLocalListener(c, requestQueue[p].origin);

			// send the found down the queue
			d=requestQueue[p].origin;
			if((clients[d].inuse == NODE_TYPE_PEER_IN) ||
			   (clients[d].inuse == NODE_TYPE_PEER_OUT))
			{
				printf("Sending down to peer %d\n", d);
				send(clients[d].csock, myBuf, strlen(myBuf), 0);
			}
			else if(clients[d].inuse == NODE_TYPE_IRC)
			{
				// this request came from an IRC client
				// which means that it was initiated by an IRC
				// JOIN command - now that we have a channel
				// structure here, relay the join.
				sendChannelJoin(channel, clients[d].nick, clients[d].ident, -1, NULL);
			}
		}
		else
		{
			char newCookie[1000];
			char message[10000];
			generateCookie(newCookie);
			createRequest(REQUEST_CHANNEL_UNLISTEN, i, newCookie);

			printf("Request for %s already filled - sending Unlisten\n");
			
			// we do have the channel - unqueue
			sprintf(message, "ChannelUnlisten%s %s\n", channel, newCookie);
			send(clients[i].csock, message, strlen(message), 0);
		}
	}
	else if(strncasecmp(myBuf, "Names#", 6)==0)
	{
		char *d=myBuf+5;
		char channel[1000];
		char cookie[1000];
		int q;
		sscanf(d, "%s %s\n", channel, cookie);

		// this *should* be associated with a join cookie...send it
		// back down it's origin chain
		q=getQueueNum(cookie);
		printf("%s -> %s (%d)\n", channel, cookie, q);
		if(q>=0)
		{
			int o=requestQueue[q].origin;
			printf("origin: %d\n", o);
			if((clients[o].inuse==NODE_TYPE_PEER_IN)||
			   (clients[o].inuse==NODE_TYPE_PEER_OUT))
			{
				send(clients[o].csock, myBuf, strlen(myBuf), 0);
			}
			else if(clients[o].inuse==NODE_TYPE_IRC)
			{
				int c=0;
				char *list;
				while(c<strlen(d) && d[c]!=':') c++;
				if(c<strlen(d)) list=d+c; else list=d;
				sendIrcNamesList(o, channel, list);
			}
		}
	}
	else if(strncasecmp(myBuf, "Join#", 5)==0)
	{
		char *d=myBuf+4;
		char channel[1000];
		char nick[1000];
		char cookie[1000];
		char ident[1000];
		int which;
	
		sscanf(d, "%s %s %s %s", channel, nick, ident, cookie);
		printf("%s\n", d);

		// search for channel here
		which=findChannelByName(channel);

		// otherwise it's an unrouteable message, for now, 
		// and we drop it - this shouldn't happen unless someone
		// has a buggy node
		if(which>=0)
		{
			if(channels[which].local)
			{
				char buf[1000];
				char list[10000];
				int x;
				// the channel is local - join it
				addNickToChannel(channel, nick);
				// send names down the chain
				createNickList(list, channel);
				sprintf(buf, "names%s %s :%s\n", channel, cookie, list);
				send(clients[i].csock, buf, strlen(buf), 0);
			}
			else
			{
				// send up to the next level
				send(channels[which].origin, myBuf, strlen(myBuf), 0);
			}
		}
	}
	else if(strncasecmp(myBuf, "message#", 8)==0)
	{
		char nick[1000];
		char target[1000];
		char cookie[1000];
		char ident[1000];
		char *message;		
		char *d=myBuf+7;
		int c=0;

		sscanf(d, "%s %s %s %s", target, nick, ident, cookie);
		if(checkCookie(cookie, i))
		{
			while(c<strlen(d) && d[c]!=':') c++;
			if(c<strlen(d)) message=d+c+1; else message=d;
			printf("Sending message: %s!%s %s: %s, cookie %s\n", nick, ident, target, message, cookie);
			sendIrcChannelMessage(nick, ident, target, message, i, cookie);
		}
	}
	else
	{
		printf("*** unknown node message: %s\n", myBuf);
	}
}

void createNickList(char *list, char *channel)
{
	int which;
	int x;
	which=findChannelByName(channel);
	list[0]=0;
	for(x=0;x<channels[which].numNicks;x++)
	{
		strcat(list, channels[which].nickList[x]);
		strcat(list, " ");
	}
}

void sendIrcNamesList(int i, char *channel, char *list)
{
	char buf[1000];
	printf("SendIrcNamesList(%d, %s, %s)\n", i, channel, list);
	sprintf(buf, ":%s 353 %s = %s :%s\n", servername, clients[i].nick, channel, list);
       	send(clients[i].csock, buf, strlen(buf), 0);
	sprintf(buf, ":%s 366 %s %s :End of /NAMES list.\n", servername, clients[i].nick, channel);
       	send(clients[i].csock, buf, strlen(buf), 0);
}

void createRemoteChannelHere(char *channel, char *cookie, int i)
{
	int which;
	char message[1000];

	printf("Creating channel here - %s\n", channel);
	// create
	createChannel(channel, TRUE);
	
	// connect listener
	which=findChannelByName(channel);
	addLocalListener(which, i);

	// send to the remote end
	sprintf(message, "ChannelFound%s %s\n", channel, cookie);
	send(clients[i].csock, message, strlen(message), 0);
}

void sendNoRoute(char *cookie)
{
	int num=getQueueNum(cookie);
	if(num>= -1)
	{
		char message[1000];
		sprintf(message, "NoRouteHere %s\n", cookie);
		send(clients[requestQueue[num].origin].csock, message, strlen(message), 0);
	}
}

int getQueueNum(char *cookie)
{
	int x;
	for(x=0;x<RQUEUESIZE;x++)
	{
		if(strcmp(requestQueue[x].cookie, cookie)==0)
			return x;
	}
	return -1;
}

int checkCookie(char *cookie, int i)
{
	int x;
	for(x=0;x<RQUEUESIZE;x++)
	{
		if(strcmp(requestQueue[x].cookie, cookie)==0)
		{
			char message[1000];
			sprintf(message, "NoRouteHere %s\n", cookie);
			send(clients[i].csock, message, strlen(message), 0);
			return FALSE;
		}
	}
	return TRUE;
}

void processIrcLine(int len, int i)
{
	char *myBuf;
	char cmd[1000];
	char buf[5000];
	
	// copy to my buffer
	myBuf=(char *)malloc(len+10);
	memcpy(myBuf, clients[i].buffer, len);
	myBuf[len]=0;
	
	// clear from original buffer
	clients[i].bufferLevel-=len;
	memmove(clients[i].buffer, clients[i].buffer+len, clients[i].bufferLevel);
	
	//printf("processIrcLine: %d, %s\n", len, myBuf);

	// now process....
	if(strncasecmp(myBuf, "IAMNODE", 7)==0)
	{
		// node is actully an incoming peer, not an IRC connection ;)
		clients[i].inuse=NODE_TYPE_PEER_IN;
	}
	else if(strncasecmp(myBuf, "USER", 4)==0)
	{
		char mode[1000];
		sscanf(myBuf, "%s %s %s", cmd, clients[i].ident, mode);
		if(verbosity>1)
			printf("Setting user: %s, mode %s\n", clients[i].ident, mode);
	}
	else if(strncasecmp(myBuf, "NICK", 4)==0)
	{
		sscanf(myBuf, "%s %s", cmd, clients[i].nick);
		if(verbosity>1)
			printf("Setting nick: %s\n", clients[i].nick);
	}
	else if(strncasecmp(myBuf, "MODE", 4)==0)
	{
		// send back invisible as the mode for now ;)
		//sprintf(buf, ":%s MODE %s :+i\n", clients[i].nick, clients[i].nick);
          	//send(clients[i].csock, buf, strlen(buf), 0);
	}
	else if(strncasecmp(myBuf, "JOIN", 4)==0)
	{
		char channel[1000];
		int st;
		int which;
		int x;
		sscanf(myBuf, "%s %s", cmd, channel);
		printf("Joining %s\n", channel);
		printf("FIXME: search for channel on next node...\n");
		

		if(addChannelListener(channel, i))
		{
			// the connection is local
			char list[10000];
			printf("The connection is local...\n");
			addNickToChannel(channel, clients[i].nick);
			createNickList(list, channel);
			// don't exclude this - turns out the IRC client needs it to sync...
			sendChannelJoin(channel, clients[i].nick, clients[i].ident, -1, NULL);
			sendIrcNamesList(i, channel, list);
		}
		else
		{
			// We don't have the local listener here....
			// the addChannelListener command starts the
			// initiation, and we completle the join
			// later
			printf("The connection is remote...\n");
		}
	}
	else if(strncasecmp(myBuf, "PRIVMSG", 7)==0)
	{
		char target[1000];
		char *message;
		int x;
		// PRIVMSG #channel :text
		sscanf(myBuf, "%s %s", cmd, target);
		message=myBuf;
		for(x=0;x<strlen(myBuf);x++)
			if(myBuf[x]==':')
			{
				message=myBuf+x+1;
				goto mmm;
			}
mmm:
		sendIrcChannelMessage(clients[i].nick, clients[i].ident, target, message, i, NULL);
	}
	else if(strncasecmp(myBuf, "WHO", 3)==0)
	{
		char channel[1000];
		int which;
		int x;
		sscanf(myBuf, "%s %s", cmd, channel);
		which=findChannelByName(channel);
		// line spereated nick list...
		// server 352 nick channel nick server server nick H :0 name
		// FIXME: get real info...
		for(x=0;x<channels[which].numNicks;x++)		
		{
			sprintf(buf, ":%s 352 %s %s %s %s %s %s H :0 %s\n", servername, channels[i].nickList[x], channel, channels[i].nickList[x], servername, servername, channels[i].nickList[x], channels[i].nickList[x]);
		}
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 315 %s %s :End of /WHO list.\n", servername, clients[i].nick, channel);
          	send(clients[i].csock, buf, strlen(buf), 0);
	}
	else
	{
		printf("I don't know how to handle line: %s\n", myBuf);
	}

	// check if we need to show the user the MOTD stuff yet
	if(clients[i].nick[0]!=0 && clients[i].ident[0]!=0 && clients[i].seenMotd==0)
	{
		clients[i].seenMotd=1;
		//sprintf(buf, ":%s 000 %s :Welcome to Invisible IRC v0.02\n", servername, clients[i].nick);
          	//send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 001 %s %s Invisible IRC 0.02 by 0x90 and Fish\n", servername, clients[i].nick, servername);
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 251 %s :There are 0 users, 0 services, and 0 servers\n", servername, clients[i].nick);
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 253 %s 0 :Unknown Connections\n", servername, clients[i].nick);
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 254 %s 0 :Channels Formed\n", servername, clients[i].nick);
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s 372 %s :End of /MOTD command.\n", servername, clients[i].nick);
          	send(clients[i].csock, buf, strlen(buf), 0);
		sprintf(buf, ":%s MODE %s :+i\n", clients[i].nick, clients[i].nick);
          	send(clients[i].csock, buf, strlen(buf), 0);


	}
	free(myBuf);

}

// FIXME: return false if the nick is already in that channel
int addNickToChannel(char *channel, char *nick)
{
	int which=findChannelByName(channel);

	if(channels[which].local)
	{
		printf("adding %s to local channel %d\n", nick, which);
		strcpy(channels[which].nickList[channels[which].numNicks], nick);
		channels[which].numNicks++;
		// broadcast to listeners
		return TRUE;
	}
	else
	{
		printf("need to add %s to remote channel %s\n", nick, channel);
	}
	return FALSE;
}

// NOTE FOR USING THIS FUNCTION:
// 
// you should exlude sending the message back to the client that you got it 
// from.  clients relaying messages should manually relay messages that they
// send out to nodes back to other clients who need them, again excluding the
// client who send them.
//
void sendIrcChannelMessage(char *nick, char *ident, char *target, char *message, int exclude, char *cookie)
{
	int which;
	int i;
	int x;
	int y;
	int num=0;
	char buf[4096];
	char mc[4096];

	if(cookie==NULL)
	{
		generateCookie(mc);
		createRequest(REQUEST_CHANNEL_MESSAGE, exclude, mc);
	}
	else
		strcpy(mc, cookie);

	printf("Sending text %s to channel %s\n", message, target);
	which=findChannelByName(target);
	
	for(x=0;x<channels[which].numListeners;x++)
	{
		i=channels[which].listeners[x];
		if(i!=exclude)
		{
			num++;
			switch(clients[i].inuse)
			{
				case 0: 
					break;
				case NODE_TYPE_IRC:
					sprintf(buf, ":%s!%s@%s PRIVMSG %s :%s\n", nick, ident, servername, target, message);
			          	send(clients[i].csock, buf, strlen(buf), 0);
					break;				
				default:
					sprintf(buf, "message%s %s %s %s :%s\n", target, nick, ident, mc, message);
			          	send(clients[i].csock, buf, strlen(buf), 0);
					break;
			}
		}
	}
	// send on up to the next node
	if(!channels[which].local)
	{
		int w=channels[which].origin;
		if(w!=exclude)
		{
			sprintf(buf, "message%s %s %s %s :%s\n", target, nick, ident, mc, message);
	          	send(clients[w].csock, buf, strlen(buf), 0);
			num++;
		}
	}
	printf("Send %s : %s to %d clients\n", target, message, num);
}

void createChannel(char *channelName, int local)
{
	printf("Creating channel %s\n", channelName);
	strcpy(channels[numChannels].name, channelName);
	channels[numChannels].numListeners=0;
	channels[numChannels].numNicks=0;
	channels[numChannels].local=local;
	numChannels++;
}

void generateCookie(char *where)
{
	int x;
	for(x=0;x<COOKIELEN;x++)
		where[x]=allowable[random()%strlen(allowable)];
	where[COOKIELEN-1]=0;
}

void requestRemoteListener(char *channel, int i)
{
	char buf[1000];
	char cookie[COOKIELEN];
	int num;
	int r;
	generateCookie(cookie);
	printf("requesting remote listener for %s, cookie %s\n", channel, cookie);

	// create the reqest struct
	r=createRequest(REQUEST_CHANNEL_LISTEN, i, cookie);
	
	// send the request to all connected nodes
	sprintf(buf, "channel%s %s\n", channel, cookie);
	num=sendToAllNodes(buf, i, r);
}

void createLocalChannel(char *channel, int i)
{
	int which;
	printf("Creating local channel and listening: %s\n", channel);
	addLocalListener(which, i);
}

int sendToAllNodes(char *command, int exclude, int r)
{
	int i;
	int num=0;
	for(i=0;i<MAXNODES;i++)
	{
		if(i!=exclude)
		{
			if( (clients[i].inuse==NODE_TYPE_PEER_IN) ||
			    (clients[i].inuse==NODE_TYPE_PEER_OUT))
			{
				send(clients[i].csock, command, strlen(command), 0);
				num++;
			}
		}
	}
	requestQueue[r].probes=num;
	return num;
}

void addLocalListener(int which, int i)
{
	// add the listener to the channel
	int n=channels[which].numListeners;
	channels[which].listeners[n]=i;
	channels[which].numListeners++;
}

int addChannelListener(char *channelName, int i)
{
	int which;
	printf("Adding listener to channel %s for socket %d\n", channelName, i);

	// check if we have the channel locally
	which=findChannelByName(channelName);

	if(which>=0)
	{
		// we do.... add local listener
		addLocalListener(which, i);
		return TRUE;
	}
	else
	{
		// find the channel remotely....
		if(connectedNodes>0)
		{
			printf("Requesting remote listener...\n");
			requestRemoteListener(channelName, i);
			return FALSE;
		}
		else
		{
			printf("No node connections... local server only\n");
			createChannel(channelName, TRUE);
			which=findChannelByName(channelName);
			addLocalListener(which, i);
			return TRUE;
		}
	}
	return FALSE;
}

int findChannelByName(char *channelName)
{
	int x;
	for(x=0;x<numChannels;x++)
		if(strcasecmp(channelName, channels[x].name)==0)
			return x;
	return -1;
}

void handleLocalConnection(SOCKET lsock, fd_set *fdsr)
{
	int i;
	// check for new local connections
	if(FD_ISSET(lsock, fdsr))
	{
		struct sockaddr_in cremote;
		socklen_t crs;
		struct timeval tv = {1,0};
		SOCKET csock;

		bzero(&cremote, sizeof(cremote));
		if(verbosity>1)
			printf("Aceepting new connection...\n");

		// accept the connection
      		csock = accept(lsock, (struct sockaddr *)&cremote, &crs);
		if(csock < 0)
		{
			perror("accept");
			exit(30);
		}
     
		// get an empty slot
		for (i = 0; i < MAXNODES; i++)
			if (!clients[i].inuse) break;
          	
		// place data in to the slot - current socket
		clients[i].csock = csock;
		clients[i].activity = now;
		strcpy(clients[i].remote.host, inet_ntoa(cremote.sin_addr));

		printf("Connection from: %s\n", inet_ntoa(cremote.sin_addr));

		// We assume the node is a legacy IRC client unless told
		// otherwise
        	clients[i].inuse = NODE_TYPE_IRC;
  		clients[i].nick[0]=0;
  		clients[i].realName[0]=0;
 		clients[i].ident[0]=0;
		clients[i].seenMotd=0;
		clients[i].pubKey[0]=0;
	}
}

struct sockaddr_in getLocalAddr(int port)
{
	struct sockaddr_in laddr;
	/* determine the listener address and port */
	bzero(&laddr, sizeof(struct sockaddr_in));
	laddr.sin_family = AF_INET;
	laddr.sin_port = htons((unsigned short)port);
	laddr.sin_addr.s_addr = htonl(0);
  
/*	if (!laddr.sin_port) {
	    fprintf(stderr, "invalid listener port\n");
	    exit(20);
	}*/
	return laddr;
}

int createListener(int port, struct sockaddr_in *laddri)
{
	struct sockaddr_in laddr;
	int lsock;
  
	laddr=getLocalAddr(port);
  
  	/* create the listener socket */
	if ((lsock = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(20);
	}

	if (bind(lsock, (struct sockaddr *)&laddr, sizeof(laddr))) {
		perror("bind");
		exit(20);
	}

	
	if (listen(lsock, 5)) {
		perror("listen");
		return 20;
	}

	/* change the port in the listener struct to zero, since we will
	 * use it for binding to outgoing local sockets in the future. */
	laddr.sin_port = htons(0);

	*laddri=laddr;

	return lsock;
}
