//
//masq.c
//
//Masquerading protocol server
//
//
//-UserX 2001/12/07

#include <stdlib.h>
#include "masq.h"
#include "noderef.h"
#include "protocfg.h"
#include "striip.h"
#include "pf-masq.h"
#include "sockserv.h"
#include "logger.h"
#include "random.h"
#include "sock.h"

//PointerArrayHandle *sockarray = NULL;
PipeFaceArray *PFA = NULL;

void masqAddIn(SockHandle *sh, int *result) {
	PipeFace *pf;
	//ptrarrayAdd(sockarray, sh);
	pf = pfmasqMake("", ""); //todo: revisit   pipefacename, options
	pipefaceInit(pf, sh->IOPipe.backPipe);
	pfaAdd(PFA, pf);

	*result = 0;
	return;
}

void masqDoPFA(void) {
	int i;
	for(i = 0; i < PFA->size; i++) {
		if(PFA->data[i] != NULL) {
			pipeGenericRead(&PFA->data[i]->IOPipe);
			pipeGenericWrite(&PFA->data[i]->IOPipe);
			if(pipeStatus(PFA->data[i]->IOPipe.backPipe) & PSTATUS_CLOSED) {
				pipefaceClose(PFA->data[i]);
				PFA->data[i] = NULL;
			}
		}
	}
}

//todo: break this apart
int main(int argc, char* argv[]) {
	NodeRef *nr;
	//todo: configuration
	setLogFileName("masq.log");

	randomInit();
	SocketAtStart();

	lnraCheckMake();
	nr = lnraAdd(protocolmasqhost);
	nr->PortNum = protocolmasqport;
	nr->Protocol = stringCopy("masq");

	sockservInit(masqAddIn);
	sockservStartListen();

	//sockarray = ptrarrayMake();
	PFA = pfaMake();

	while(1) {
		sockservProcess();
		masqDoPFA();
	}

	return 0;
}

