//
//p-crypt.c
//
//Cryptographic pipe
//
//Current just has *very* crude cryptography. Just for testing purposes.
//
//
//-UserX 2001/11/13

#include <stdlib.h>

#include "datablck.h"
#include "memiip.h"
#include "p-crypt.h"
#include "crypt.h"
#include "striip.h"

#include "sock.h"

PipeCrypt blankpipecrypt = BLANKPIPECRYPT;


//#define BYTEVAL 0x02

Pipe *pipecryptMake(char *pipename, char *options) {
	PipeCrypt *pc = memCopy(&blankpipecrypt, sizeof(PipeCrypt), "PipeCrypt", NULL);//xiclone(&blankpipecrypt, sizeof(PipeCrypt));
	pipeInitFunctions((Pipe *) pc, 
			(PipeFuncIn) pipecryptRead, (PipeFuncOut) pipecryptWrite, 
			(PipeFuncAttach) pipecryptAttach, (PipeFuncDetach) pipecryptDetach, 
			(PipeFuncClose) pipecryptClose, (PipeFuncStatus) pipecryptStatus);
	pipeInit((Pipe *) pc);
	pc->cryptstream = csMake();
	return (Pipe *)pc;
}

void pipecryptFree(PipeCrypt *pc) {
	pipeFree(&pc->IOPipe);
	csFree(pc->cryptstream);
	memFree(pc);//xifree(pc);
}

void pipecryptRead(PipeCrypt *thispipe, Pipe **errPipe) {
	*errPipe = pipeGenericRead(thispipe->IOPipe.backPipe);
	if(*errPipe == NULL) {
		csRead(thispipe->cryptstream);
	}
}

void pipecryptWrite(PipeCrypt *thispipe, Pipe **errPipe) {
	csWrite(thispipe->cryptstream);
	*errPipe = pipeGenericWrite(thispipe->IOPipe.backPipe);
}


void pipecryptAttach(PipeCrypt *thispipe) {
	SockHandle *sh;
	NodeRef *nr;
	//technicly should have been done on the attaching the backpipe
	//thispipe->cryptstream->backPipe = thispipe->IOPipe.backPipe;
	thispipe->cryptstream->thisPipe = &(thispipe->IOPipe);
	sh = (SockHandle *)pipeGetEnd((Pipe *)thispipe);
	if(sh->direction == SOCK_DIR_IN) {
		nr = sh->localnoderef;
	} else {
		nr = sh->noderef;
	}
	if(nr != NULL) {
		if(!isStringBlank(nr->PrivateKey)) {
			thispipe->cryptstream->privkey = bignumFromHex(nr->PrivateKey);
		}
		if(!isStringBlank(nr->PublicKey)) {
			thispipe->cryptstream->setremotekey = bignumFromHex(nr->PublicKey);
		}
	}
}

void pipecryptDetach(PipeCrypt *thispipe) {
	pipecryptFree(thispipe);
}

void pipecryptClose(PipeCrypt *thispipe) {
}

//this can block data from further down the chain so clear the READ bit
void pipecryptStatus(PipeCrypt *thispipe, int *status) {
	*status &= ~PSTATUS_READ;
}
