

#include <stdio.h>
#include <stdlib.h>



int errorcount = 0;
int ununix = 0;

void help() {
	printf(
			"Usage:\n"
			"\tundos [options] <filespec> [<filespec> ...]\n"
			"\t\t-u un-unix a file\n"
		);
	exit(0);
}


void doFile(char *filename) {
	FILE *fhr = NULL;
	FILE *fhw = NULL;
	
	char tempfilename[1024] = "temptemp.tmp"; //

	int c = 0;

	printf("%s ...", filename);

	fhr = fopen(filename, "r");
	if(fhr == NULL) {
		printf(" Unable to open file.\n");
		return;
	}
	fhw = fopen(tempfilename, "w");
	if(fhw == NULL) {
		fclose (fhr);
		printf(" Unable to open tempfile.\n");
		return;
	}

	c = fgetc(fhr);
	while(c != EOF) {
		switch(c) {
		case 0x26:
		case 0:
		case '\r':
			break;
		case '\n':
			if(ununix) {
				fputc('\r', fhw);
			}
		default:
			fputc(c, fhw);
		}
		
		c = fgetc(fhr);
	}

	fclose (fhr);
	fclose (fhw);
	unlink(filename);
	rename(tempfilename, filename);
	printf(" done.\n");
}

//list and process all the files mathing filespec.
void doFiles(char* filespec) {
	//todo: turn filespec into a list of matching files
	doFile(filespec);
}

int main(int argc, char **argv){

	int i;
	if(argc == 1) {
		help();
	}
	for(i = 1; i < argc; i++) {
		if(strcmp("-h", argv[i]) == 0) {
			help();
		} else if(strcmp("-u", argv[i]) == 0) {
			ununix = 1;
		} else {
			doFiles(argv[i]);
		}
	}
}

