//
//wingui.c
//
//Contains windows gui and interface functions. Also contains WinMain().
//
//-UserX 2001/11/05

#include "compat.h"
#ifdef _WINDOZE_

#include <windows.h>
#include <winsock.h>

#include <shellapi.h>
#include <stdio.h>

#include "isproxy.h"

#include "striip.h"
#include "random.h"

#include "config.h"
#include "wingui.h"

#include "nodeserv.h"
#include "sockserv.h"

#include "crypt-dh.h"

#include "protocol.h"

#include "resource.h"
#include "p-nodet.h"


#include "iip-ui.h"
#include "ui-win.h"

#define NOTIFY (WM_USER + 1)

  /* Winsock needs additional startup activities */
WSADATA wsadata;
HWND hwnd;

HINSTANCE hinst = NULL;

int settingsshown = 0;

BOOL AddTrayIcon(LPSTR ToolTip,UINT uID, HINSTANCE hinstance)
{
	BOOL result;
	NOTIFYICONDATA IconDat;
	HICON hIcon1;   /* icon handle            */ 
	
	hIcon1 = LoadIcon(hinstance, MAKEINTRESOURCE(IDI_ICON_IIP)); 


	IconDat.cbSize	= sizeof(NOTIFYICONDATA);
	IconDat.hWnd	= hwnd;
	IconDat.uID		=uID;
	//strcpy(IconDat.szTip,ToolTip);
	memcpy(IconDat.szTip, ToolTip, sizeof(IconDat.szTip) - 1);
	IconDat.szTip[sizeof(IconDat.szTip) - 1] = 0;
	IconDat.uCallbackMessage = NOTIFY;
	IconDat.hIcon = hIcon1;
	IconDat.uFlags = NIF_MESSAGE |  
					 NIF_ICON |     
					 NIF_TIP;  
	result = Shell_NotifyIcon(NIM_ADD, &IconDat); 

//	if (hIcon1) 
  //      DestroyIcon(hIcon1); 

	
	return result;
}
  
BOOL DeleteTrayIcon(UINT uID) 
{
	BOOL result;
	NOTIFYICONDATA IconDat;
	IconDat.cbSize	= sizeof(NOTIFYICONDATA);
	IconDat.hWnd	= hwnd;
	IconDat.uID		=uID;
	
	result = Shell_NotifyIcon(NIM_DELETE, &IconDat); 
	return result;
}
/*
BOOL APIENTRY DProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam) 
{
	char *msg;
	//TCHAR ftext[1025];
	BOOL boolResult;


    switch (message) { 
	case WM_COMMAND: 
        switch (LOWORD(wParam)) { 
        case IDOK: 
			localPort = GetDlgItemInt(hwndDlg, IDC_EDIT_PORTNUM, &boolResult, FALSE);
			if(boolResult && localPort >=1 && localPort <=65535) {
				EndDialog(hwndDlg, wParam); 
				//wsprintf(ftext,"In your IRC client program, log into /server localhost %d and join channel #anonymous\0",localPort);
				SetFocus(hwnd);
				msg = stringJoinMany(
					"In your IRC client, log on to IIRC by typing \"/server localhost:",
					intToString(localPort),
					"\" and then type \"/join #anonymous\".",
					NULL);
				MessageBox(hwnd, msg, "Connect to IIP", MB_OK);
				stringFree(msg);
				return TRUE;
			}
			localPort = -1;
			MessageBox(hwnd, "Bad port number must be between 1 and 65535", "IIP",MB_OK);
			SetFocus(hwndDlg);
			return FALSE;
			
        case IDCANCEL: 
            EndDialog(hwndDlg, wParam); 
			PostQuitMessage(0);
            return TRUE; 
        } 

        // Place message cases here. 
 
    default: 
        return FALSE; 
    } 
} 
*/
/*
BOOL APIENTRY DProcRS(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam) 
{
	BOOL boolResult;

	FILE *FH;

	int newport;
	char *s;
	char *sprivkey;
	char *spubkey;
	BigNum *privkey;
	BigNum *pubkey;

	int count;
	int i;
	NodeRef *nr = NULL;

    switch (message) { 
	case WM_INITDIALOG:
		for(i = 0; i < LNRA->size; i++) {
			if(stringCaseCompare(LNRA->data[i].Special, "entry") != 0) {
				nr = &LNRA->data[i];
				break;
			}
		}
		if(nr == NULL) {
			nr = lnraAdd("0.0.0.0");
			nr->PortNum = 1024 + randomint(30000);//PROTOCOL_DEFAULTPORT;
			nr->Protocol = "crypt:raw";
		}
		if(!isStringBlank(hostname)) {
			SetDlgItemText(hwndDlg, IDC_EDIT_RELAY_HOST, hostname);
		}
		if(!isStringBlank(nr->PrivateKey)) {
			SetDlgItemText(hwndDlg, IDC_EDIT_PRIVATE_KEY, nr->PrivateKey);
			privkey = bignumFromHex(nr->PrivateKey);
			pubkey = dhGeneratePubKey(privkey);
			s = bignumToHex(pubkey);
			bignumFree(privkey);
			bignumFree(pubkey);
			SetDlgItemText(hwndDlg, IDC_EDIT_PUBLIC_KEY, s);
			stringFree(s);
		}
		SetDlgItemInt(hwndDlg, IDC_EDIT_RELAY_PORT, nr->PortNum, FALSE);
		return FALSE;
	case WM_COMMAND: 
        switch (LOWORD(wParam)) { 
        case IDOK: 
			newport = GetDlgItemInt(hwndDlg, IDC_EDIT_RELAY_PORT, &boolResult, FALSE);
			if(!(boolResult && newport >=1 && newport <=65535)) {
				MessageBox(hwnd, "Bad port number must be between 1 and 65535", "IIP", MB_OK);
				SetFocus(hwndDlg);
				return FALSE;
			}
			s = stringMake(2048);
			count = GetDlgItemText(hwndDlg, IDC_EDIT_RELAY_HOST, s, 2048);
			/ *
			if(isStringBlank(s)) {
				MessageBox(hwnd, "No host name specified!", "IIP", MB_OK);
				SetFocus(hwndDlg);
				return FALSE;
				stringFree(s);
			}
			* /
			sprivkey = stringMake(2048);
			count = GetDlgItemText(hwndDlg, IDC_EDIT_PRIVATE_KEY, sprivkey, 2048);
			spubkey = stringMake(2048);
			count = GetDlgItemText(hwndDlg, IDC_EDIT_PUBLIC_KEY, spubkey, 2048);
			for(i = 0; i < LNRA->size; i++) {
				if(stringCaseCompare(LNRA->data[i].Special, "entry") != 0) {
					nr = &LNRA->data[i];
					break;
				}
			}

			if(nr != NULL) {
				nr->PortNum = newport;
				nr->PrivateKey = stringReplace(nr->PrivateKey, sprivkey);
			}
			
			
			hostname = stringReplace(hostname, s);

			//write mynode.ref
			FH = fopen("mynode.ref", "w");
			if(!isStringBlank(networkKey)) {
				fprintf(FH, "networkid = %s\n", networkKey);
			}
			if(!isStringBlank(networkProtocol)) {
				fprintf(FH, "networkprotocol = %s\n", networkProtocol);
			}
			fprintf(FH, "host = %s\n", s);
			fprintf(FH, "port = %d\n", nr->PortNum);
			fprintf(FH, "protocol = %s\n", nr->Protocol);
			if(!isStringBlank(spubkey)) {
				fprintf(FH, "publickey = %s\n", spubkey);
			}
			fclose(FH);

			sockservStartListen();
			nodeservWriteListenRef();
			//writeConfigFile();
			configWrite();

			EndDialog(hwndDlg, wParam);
			SetForegroundWindow(hwnd); // Our MessageBox pops up in front
			i = MessageBox(hwnd, "Do you wish to announce your relay node to the network?", "IIP - Submit node?", MB_YESNO | MB_DEFBUTTON2);
			if(i == IDYES) {
				nr = noderefCopy(nr);
				stringFree(nr->PublicKey);
				stringFree(nr->HostName);
				nr->PublicKey = spubkey;
				nr->HostName = s;
				//inform.invisiblenet.net/submitrelay.php
				//if(nodeservSubmitNode(nr, "mail.invisiblenet.net", 25, "relay@invisiblenet.net") != 0)
				if(nodeservSubmitNode(nr, informpage, informhost, informport) != 0) {
					MessageBox(hwnd, "A problem was encontered while submitting your noderef.", "IIP - Submit error", MB_OK);
				} else {
					MessageBox(hwnd, "Your noderef was successfully announced.", "IIP - Noderef submit OK", MB_OK);
				}
				noderefFree(nr);
			}

			stringFree(sprivkey);
			stringFree(spubkey);
			stringFree(s);


			SetFocus(hwnd);
			return TRUE;
        case IDCANCEL:
            EndDialog(hwndDlg, wParam);
            return TRUE;
		case IDC_RELAY_MAKE_KEY:
			privkey = dhGeneratePrivKey();
			pubkey = dhGeneratePubKey(privkey);
			
			s = bignumToHex(privkey);
			SetDlgItemText(hwndDlg, IDC_EDIT_PRIVATE_KEY, s);
			stringFree(s);

			s = bignumToHex(pubkey);
			SetDlgItemText(hwndDlg, IDC_EDIT_PUBLIC_KEY, s);
			stringFree(s);

			bignumFree(privkey);
			bignumFree(pubkey);

			return TRUE;
		}
    default: 
        return FALSE; 
	}
}
*/
/*
BOOL APIENTRY DProcCS(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam) 
{
	//TCHAR ftext[1025];
	BOOL boolResult;

	int newport;
	char *host;
	int count;
	int i;
	NodeRef *nr = NULL;

    switch (message) { 
	case WM_INITDIALOG:
		nraCheckMake();
		for(i = 0; i < LNRA->size; i++) {
			if(stringCaseCompare(LNRA->data[i].Special, "entry") == 0) {
				nr = &LNRA->data[i];
				break;
			}
		}
		if(nr == NULL) {
			nr = lnraAdd("127.0.0.1");
			nr->Special = "entry";
			if(localPort == -1) {
				localPort = 6667;
			}
			nr->PortNum = localPort;
			nr->Protocol = networkProtocol;
			nr->PublicKey = networkKey;
		}
		if(strcmp(nr->HostName, "127.0.0.1") == 0) {
			CheckDlgButton(hwndDlg, IDC_RADIO_LOCALHOST, BST_CHECKED);
		} else if(strcmp(nr->HostName, "0.0.0.0") == 0) {
			CheckDlgButton(hwndDlg, IDC_RADIO_ANY, BST_CHECKED);
		} else {
			CheckDlgButton(hwndDlg, IDC_RADIO_OTHER, BST_CHECKED);
			SetDlgItemText(hwndDlg, IDC_EDIT_OTHER, nr->HostName);
		}
		nr = NULL;
		for(i = 0; i < LNRA->size; i++) {
			if(stringCaseCompare(LNRA->data[i].Special, "entry") != 0) {
				nr = &LNRA->data[i];
				break;
			}
		}
		if(nr == NULL) {
			EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), TRUE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), TRUE);
			EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), FALSE);
			CheckDlgButton(hwndDlg, IDC_RADIO_USER, BST_CHECKED);
		} else {
			if(publicrelaynode == 0) {
				EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), TRUE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), TRUE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
				CheckDlgButton(hwndDlg, IDC_RADIO_PRIVATE, BST_CHECKED);
			} else {
				EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), FALSE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), FALSE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), FALSE);
				EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
				CheckDlgButton(hwndDlg, IDC_RADIO_PUBLIC, BST_CHECKED);
			}
		}

		if(autogetnoderefs != 0) {
			CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF, BST_CHECKED);
		}
		if(nodetransget != 0) {
			CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET, BST_CHECKED);
		}
		/ *
		if(publicrelaynode != 0) {
			CheckDlgButton(hwndDlg, IDC_CHECK_RELAY_NODE, BST_CHECKED);
		}
		* /
		SetDlgItemInt(hwndDlg, IDC_EDIT_CLIENT_PORT, localPort, FALSE);
		return FALSE;
	case WM_COMMAND: 
        switch (LOWORD(wParam)) { 
        case IDOK: 
			newport = GetDlgItemInt(hwndDlg, IDC_EDIT_CLIENT_PORT, &boolResult, FALSE);
			if(!(boolResult && newport >=1 && newport <=65535)) {
				MessageBox(hwnd, "Bad port number must be between 1 and 65535", "IIP", MB_OK);
				SetFocus(hwndDlg);
				return FALSE;
			}
			if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_LOCALHOST)) {
				host = "127.0.0.1";
			} else if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_ANY)) {
				host = "0.0.0.0";
			} else if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_OTHER)) {
				host = stringMake(2048);
				count = GetDlgItemText(hwndDlg, IDC_EDIT_OTHER, host, 2048);
				//todo: format checking
				if(count == 0) {
					MessageBox(hwnd, "No client access selected!", "IIP", MB_OK);
					SetFocus(hwndDlg);
					return FALSE;
				}
			} else {
				MessageBox(hwnd, "No client access selected!", "IIP", MB_OK);
				SetFocus(hwndDlg);
				return FALSE;
			}
			autogetnoderefs = IsDlgButtonChecked(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF) ? 1 : 0;
			nodetransget = IsDlgButtonChecked(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET) ? 1 : 0;
			/ *
			publicrelaynode = IsDlgButtonChecked(hwndDlg, IDC_CHECK_RELAY_NODE) ? 1 : 0;
			* /
			if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_USER)) {
				publicrelaynode = 0;
			} else if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PRIVATE)) {
				publicrelaynode = 0;
			} else if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PUBLIC)) {
				publicrelaynode = 1;
			} else {
				//todo: handle no relay radio button set
			}
			//todo: handling lack of relay settings
			for(i = 0; i < LNRA->size; i++) {
				if(stringCaseCompare(LNRA->data[i].Special, "entry") == 0) {
					nr = &LNRA->data[i];
					break;
				}
			}
			if(nr != NULL) {
				nr->PortNum = newport;
				nr->HostName = stringCopy(host);
			}
			for(i = 0; i < LNRA->size; i++) {
				if(LNRA->data[i].PortNum == localPort) {
					LNRA->data[i].PortNum = newport;
				}
			}
			localPort = newport;
			stringFree(host);
			sockservStartListen();
			nodeservWriteListenRef();
			//writeConfigFile();
			configWrite();
			EndDialog(hwndDlg, wParam);
			SetFocus(hwnd);
			return TRUE;
        case IDCANCEL:
            EndDialog(hwndDlg, wParam);
			SetFocus(hwndDlg);
            return TRUE;
		case IDC_BUTTON_RELAY_SETTINGS:
			DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG_RELAY_SETTINGS), hwnd, DProcRS);
			return TRUE;
		case IDC_BUTTON_GET_NODEREF:
			i = MessageBox(hwnd, "Do you wish to fetch the latest node.ref by HTTP? <todo: comment about anonymity issues>", "IIP - Fetch node.ref?", MB_YESNO | MB_DEFBUTTON2);
			if(i == IDYES) {
				//if(nodeservGetNodeRefs("http://63.241.8.112/iip/crypto/node.ref", "63.241.8.112", 80))
				//if(nodeservGetNodeRefs("http://www.invisiblenet.net/iip/crypto/node.ref", "63.241.8.112", 80))
				if(nodeservGetNodeRefs(refgetpage, refgethost, refgetport)) {  
					MessageBox(hwnd, "A problem was encontered while retreiving node.ref.", "IIP - Node.ref fetch error", MB_OK);
				} else {
					MessageBox(hwnd, "Successfully retrieved node.ref.", "IIP - Node.ref retrieved OK", MB_OK);
				}
			}
			return TRUE;
		case IDC_CHECK_AUTO_GET_NODEREF:
			//todo: maybe: message about anonymity concerns
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PUBLIC) && IsDlgButtonChecked(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF)) {
					MessageBox(hwndDlg, "Automatic retrieval of node.ref is not recommended behaviour for public relay nodes.", "IIP", MB_OK);
				}
				return TRUE;
			}
			return FALSE;
		case IDC_CHECK_AUTO_NODETRANSGET:
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PUBLIC) && IsDlgButtonChecked(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET)) {
					MessageBox(hwndDlg, "Automatic retrieval of node.ref is not recommended behaviour for public relay nodes.", "IIP", MB_OK);
				}
				return TRUE;
			}
			return FALSE;
		/ *
		case IDC_CHECK_RELAY_NODE:
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_CHECK_RELAY_NODE)) {
					CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF, BST_UNCHECKED);
					MessageBox(hwndDlg, "A public relay must have 24 hour availablity and a reliable connection. <todo: add more here>", "IIP", MB_OK);
				}
				return TRUE;
			}
			return FALSE;
		* /
		case IDC_RADIO_USER:
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_USER)) {
					EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), TRUE);
					CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET, BST_CHECKED);
					EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), FALSE);
					MessageBox(hwndDlg, "Any relay settings will be erased once you accept these client settings.", "IIP", MB_OK);
					return TRUE;
				}
			}
			return FALSE;
		case IDC_RADIO_PRIVATE:
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PRIVATE)) {
					EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), TRUE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_GET_NODEREF), TRUE);
					return TRUE;
				}
			}
			return FALSE;
		case IDC_RADIO_PUBLIC:
			EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_RELAY_SETTINGS), TRUE);
			if(HIWORD(wParam) == BN_CLICKED) {
				if(IsDlgButtonChecked(hwndDlg, IDC_RADIO_PUBLIC)) {
					CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF, BST_UNCHECKED);
					CheckDlgButton(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET, BST_UNCHECKED);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_GET_NODEREF), FALSE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_CHECK_AUTO_NODETRANSGET), FALSE);
					EnableWindow(GetDlgItem(hwndDlg, IDC_BUTTON_GET_NODEREF), FALSE);
					MessageBox(hwndDlg, "A public relay must have 24 hour availablity and a reliable connection. <todo: add more here>", "IIP", MB_OK);
				}
				return TRUE;
			}
			return FALSE;
		}
    default:
        return FALSE; 
	}
}
*/
LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	POINT mouse;
//	int choice;
	HMENU hmenu;
	int i;
	char *s;
	switch (msg) {
	case NOTIFY:
		//DeleteTrayIcon(5005)
		switch(lparam) {
		case WM_LBUTTONDBLCLK:
			SetForegroundWindow(hwnd); // Our MessageBox pops up in front
			//DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG_CLIENT_SETTINGS), hwnd, DProcCS);
			iipcsScreen();

			/*
			SetForegroundWindow(hwnd); // Our MessageBox pops up in front
			choice = MessageBox(hwnd, "Do you really want to stop isproxy", "Isproxy", MB_YESNO | MB_DEFBUTTON2);
			if(choice==IDYES) {
				DeleteTrayIcon(5005);
				PostQuitMessage(0);
			}
			*/
			break;
		case WM_RBUTTONUP: //WM_CONTEXTMENU:
			if(GetCursorPos(&mouse)) {
				hmenu = CreatePopupMenu();
				AppendMenu(hmenu, MF_STRING, IDM_HELP, "Help");
				if(settingsshown == 0) {
					AppendMenu(hmenu, MF_STRING, IDM_SETTINGS, "Settings");
				}
				AppendMenu(hmenu, MF_STRING, IDM_EXIT, "Exit");
				i = TrackPopupMenu(hmenu, TPM_RIGHTBUTTON | TPM_RETURNCMD , mouse.x, mouse.y, 0, hwnd, NULL); //TPM_LEFTALIGN | TPM_BOTTOMALIGN
				DestroyMenu(hmenu);
				switch(i) {
				case IDM_HELP:
					//HtmlHelp(hwnd, winhelpfile, HH_DISPLAY_TOPIC, 0);
					//todo: figure out what is needed for html help
					s = stringAppend("hh ", winhelpfile);
					WinExec(s, SW_SHOW);
					stringFree(s);
					break;
				case IDM_EXIT:
					DeleteTrayIcon(5005);
					PostQuitMessage(0);
					return(0);
				case IDM_SETTINGS:
					//IDD_DIALOG_CLIENT_SETTINGS
					//DialogBox(hinst, MAKEINTRESOURCE(IDD_DIALOG_CLIENT_SETTINGS), hwnd, DProcCS);
					if(settingsshown == 0) {
						settingsshown = 1;
						iipcsScreen();
						settingsshown = 0;
					}
					break;
				}
			}
			break;
		}
		break;
	case WM_DESTROY:
		DeleteTrayIcon(5005);			
		PostQuitMessage(0);
		return(0);
	}
	return DefWindowProc(hwnd, msg, wparam, lparam);
}




//int WINAPI WinMain2(HINSTANCE hinstance, HINSTANCE hprevinstance, LPSTR lpcmdline,int ncmdshow)
//int winguiMain(HINSTANCE hinstance, HINSTANCE hprevinstance, LPSTR lpcmdline,int ncmdshow) 
int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hprevinstance, LPSTR lpcmdline,int ncmdshow) {

  
	WNDCLASSEX			winclass;			//Unsere Klasse
	int i;
//  SOCKET lsock;
//  HANDLE stdinput,stdoutput;
//  DWORD written,read;
//  char buf[4096];
//  struct sockaddr_in laddr, oaddr;
//  struct client_t clients[MAXNODES];
	char *msg;

	hinst = hinstance;

	initfirst();

	uiSetFuncs(uiwinMake, uiwDialog);

	configReset();
	//readWinCL(lpcmdline);
	configSetWinCL(lpcmdline);
	configReadCL();
	configRead();
	configReadCL();


	/* Winsock needs additional startup activities */
	WSAStartup(MAKEWORD(1,1), &wsadata);
  
	winclass.cbSize			= sizeof(WNDCLASSEX);
	winclass.style			= CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	winclass.lpfnWndProc	= WindowProc;
	winclass.cbClsExtra		= 0;
	winclass.cbWndExtra		= 0;
	winclass.hInstance		= hinstance;
	winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	winclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	winclass.lpszMenuName	= NULL;
	winclass.lpszClassName	= "isproxy";
	winclass.hIconSm		= LoadIcon(NULL, IDI_APPLICATION);

	//Registrierung der Window Klasse


	if (!RegisterClassEx(&winclass))
		return(666);
	hwnd = CreateWindowEx(0, "isproxy", "isproxy", WS_POPUP, CW_USEDEFAULT, 0,
		CW_USEDEFAULT, 0, NULL, NULL, hinstance, NULL);

	if(makeKeys == 0) {
		if (localPort == -1) {
			nodeservClearListenRefs();
			nodeservReadListenRefFile();
			//DialogBox(hinstance, MAKEINTRESOURCE(IDD_DIALOG_GETPORTNUM), hwnd, DProc); //MAKEINTRESOURCE(101),
			//DialogBox(hinstance, MAKEINTRESOURCE(IDD_DIALOG_CLIENT_SETTINGS), hwnd, DProcCS);
			iipcsScreen();
			doconfig = 0;
			if (localPort == -1) {
				return(10);
			}
			SetFocus(hwnd);
			msg = stringJoinMany(
				"In your IRC client, log on to IIRC by typing \"/server 127.0.0.1 ",
				intToString(localPort),
				"\" and then type \"/join #anonymous\".",
				NULL);
			MessageBox(hwnd, msg, "Connect to IIP", MB_OK);
			stringFree(msg);
		} else {
		}

	}
	//i = (int) MAKEINTRESOURCE(IDR_MENU_TRAY);
	//i = GetLastError();


	AddTrayIcon("Invisible IRC running", 5005, hinstance);

/*
	if(!AllocConsole()!=0)return(999);
	//CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,0,
	//						  NULL,CONSOLE_TEXTMODE_BUFFER,NULL);
	//SetConsoleActiveScreenBuffer(stdoutput);
	stdinput = GetStdHandle(STD_INPUT_HANDLE);
	stdoutput = GetStdHandle(STD_OUTPUT_HANDLE);
	
	if(stdinput == INVALID_HANDLE_VALUE || stdoutput == INVALID_HANDLE_VALUE)return(555);

	WriteConsole(stdoutput,"\nSelect Port you would like to use to connect to:",strlen("\nSelect Port you would like to use to connect to:"),&written,NULL);
	ReadConsole( 
            stdinput,    // input handle
            buf, //localport,  // buffer to read into 
            sizeof(buf), //4,       // size of buffer
            &read,    // actual bytes read
            NULL);     // not overlapped
      
	localPort = atoi(buf);

*/
	i = init();
	return i;
}	


int dowindows() {
	MSG					winmsg;
	if (PeekMessage(&winmsg,NULL,0,0,PM_REMOVE))		//teste msg auf Nachricht, wenn ja holen
	{
		if (winmsg.message == WM_QUIT) {
			return 1;
		}
			
		TranslateMessage(&winmsg);

		DispatchMessage(&winmsg);
	}
	return 0;
}

#endif  //Ending SkyRat's code


